# Windows12
A C-like compiled programming language implemented in Haskell.

## Examples
Example programs can be found in the `test` directory.

## Usage
Note: You must have version 9.0 of the Haskell compiler GHC installed. Otherwise
Cabal will not be able to obtain the necessary dependencies.

It is recommended to use the provided `shell.nix` file to create the proper
environment. Alternatively, you can run the project from the supplied
binaries in the [releases](https://gitea.mregirouard.com/eta357/Windows-12-Compiler/releases)
section.

```shell
cabal run windows12 <input file> out.ll
llc out.ll -o out.s
gcc out.s -o out
./out
```

## Running Tests
```shell
cabal run windows12-qc
```
